Bug Hunting Session
Bug 90490 - Providing chart layout and color palette presets
Summary: Providing chart layout and color palette presets
Status: NEW
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: UI (show other bugs)
Version:
(earliest affected)
4.5.0.0.alpha0+ Master
Hardware: Other All
: medium enhancement
Assignee: Not Assigned
URL: https://wiki.documentfoundation.org/C...
Whiteboard:
Keywords:
: 96542 (view as bug list)
Depends on:
Blocks: Styles Color-Palettes Chart-Wizard
  Show dependency treegraph
 
Reported: 2015-04-06 21:18 UTC by Yousuf Philips (jay) (retired)
Modified: 2018-04-17 17:33 UTC (History)
7 users (show)

See Also:
Crash report or crash signature:


Attachments
MSO chart styles (46.94 KB, image/png)
2015-04-06 21:18 UTC, Yousuf Philips (jay) (retired)
Details
FreeOffice Color Palettes (19.16 KB, image/png)
2015-04-06 21:19 UTC, Yousuf Philips (jay) (retired)
Details
iWork chart styles (31.63 KB, image/png)
2015-04-06 21:25 UTC, Yousuf Philips (jay) (retired)
Details
Numbers ChartStyles Settings top (84.71 KB, image/png)
2015-09-18 15:15 UTC, Alex Thurgood
Details
Numbers Chart Styles Background Border general (29.86 KB, image/png)
2015-09-18 15:15 UTC, Alex Thurgood
Details
Numbers Chart Styles Background Border detail (58.23 KB, image/png)
2015-09-18 15:16 UTC, Alex Thurgood
Details
Numbers Chart Styles Shadow (26.39 KB, image/png)
2015-09-18 15:17 UTC, Alex Thurgood
Details
Numbers Chart Styles Graph type (137.48 KB, image/png)
2015-09-18 15:18 UTC, Alex Thurgood
Details
Stata: Screenshot of UI to apply the different chart styles in Stata (744.58 KB, image/png)
2015-09-18 20:37 UTC, Gerry
Details
Stata: Selection of five different chart styles applied to the same chart (38.99 KB, image/png)
2015-09-18 20:38 UTC, Gerry
Details
Chart Styles for LibreOffice (353.86 KB, application/vnd.oasis.opendocument.text)
2015-09-20 15:19 UTC, Yousuf Philips (jay) (retired)
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Yousuf Philips (jay) (retired) 2015-04-06 21:18:41 UTC
Created attachment 114660 [details]
MSO chart styles

By default, an inserted chart with three values always has blue for value 1, red for value 2 and yellow for value 3. It would be nice to be able to provide user with redefined presets of alternative color that is easy to apply, rather than the user having to modify each of the colors individually.
Comment 1 Yousuf Philips (jay) (retired) 2015-04-06 21:19:36 UTC
Created attachment 114661 [details]
FreeOffice Color Palettes
Comment 2 Yousuf Philips (jay) (retired) 2015-04-06 21:25:21 UTC
Created attachment 114662 [details]
iWork chart styles
Comment 3 A (Andy) 2015-04-07 07:14:44 UTC
Great proposal, I would really like to have this feature.
Comment 4 Bastián Díaz 2015-09-17 20:06:48 UTC
Does this only comes to the colors of charts?

See: https://bugs.documentfoundation.org/show_bug.cgi?id=93088

Please check, and if necessary, mark as duplicate.
So I can create another report, including color palettes like styles.

(to order a bit).

Cheers
Comment 5 Yousuf Philips (jay) (retired) 2015-09-18 06:41:19 UTC
(In reply to Bastián Díaz from comment #4)
> Does this only comes to the colors of charts?

The colors of the chart data series is one of the pieces that is hoped to be covered by this bug enhancement, the others being element layout and element styles.

> See: https://bugs.documentfoundation.org/show_bug.cgi?id=93088
> 
> Please check, and if necessary, mark as duplicate.
> So I can create another report, including color palettes like styles.

I think your bug maybe related to document theming (bug 90497).

As an update to this bug report, I brought up the topic of chart styles in wednesday's design meeting and discussed it with Heiko and Matthias. I've asked them to proposed data series color sets and chart element layouts, and others are welcome to do the same.

My current research on this, as well as chart styles from competing office suites can be found at the following link.

https://drive.google.com/folderview?id=0B6qJrVIa0SAlfmZTWFI4MWpCLUh0OXlnYVV5bmtoMXNVU25kRzlHNDZZQ3FDdVFvcHU1emc&usp=sharing
Comment 6 Gerry 2015-09-18 08:12:54 UTC
Dear Jay, that's great that you look into chart styles. There are two other bugs which request something very similar and might be duplicates: bug 62925 and bug 39097 and bug 62860. These bugs also include examples from statistical software like Stata and SAS. They all have chart theming/styles. If you like, I can also provide some more examples from Stata.

Overall, it would be great if something is moving with regard to chart styles. Even a simple switch between a coloured and greyscale mode (which is relevant for most publications) would be already a big step forward. 

When you think about the design of that feature, please include it well into the existing styles system in LibreOffice and not something completely separate (like the awful auto-formats did for Writer tables). It would be just superbe if it integrates nicely with the existing page-, paragraph-, character-, frame-, list-styles system in LO.
Comment 7 Gerry 2015-09-18 08:15:05 UTC
Play also see the wiki page on Chart styles: https://wiki.documentfoundation.org/Chart_styles There are also some examples from Excel and Stata.
Comment 8 Yousuf Philips (jay) (retired) 2015-09-18 13:46:14 UTC
(In reply to Gerry from comment #6)
> Dear Jay, that's great that you look into chart styles. There are two other
> bugs which request something very similar and might be duplicates: bug 62925
> and bug 39097 and bug 62860. These bugs also include examples from
> statistical software like Stata and SAS. They all have chart theming/styles.
> If you like, I can also provide some more examples from Stata.

Hi Gerry,

Yes i had read though the chart styles wiki page previously and noticed the various similar bug reports mentioned in bug 62925, but didnt go through those yet. Yes it would be good to get screenshots of how Stata presents the theming/styles and some examples of the various styles.

> Overall, it would be great if something is moving with regard to chart
> styles. Even a simple switch between a coloured and greyscale mode (which is
> relevant for most publications) would be already a big step forward. 

In order to move this forward, we have to propose some chart color sets, element layouts and element styles that can be then passed onto a developer to take the next step.

> When you think about the design of that feature, please include it well into
> the existing styles system in LibreOffice and not something completely
> separate (like the awful auto-formats did for Writer tables). It would be
> just superbe if it integrates nicely with the existing page-, paragraph-,
> character-, frame-, list-styles system in LO.

The chart styles would have to be implemented in the chart edit mode, so it wouldnt be possible to integrate it into the current styling system found in LO. It will likely be implemented in a dialog, where a user could select from a collection of various styling options to be applied to their chart, and also hopefully implement in the chart sidebar.
Comment 9 Alex Thurgood 2015-09-18 15:15:05 UTC
Created attachment 118828 [details]
Numbers ChartStyles Settings top
Comment 10 Alex Thurgood 2015-09-18 15:15:45 UTC
Created attachment 118829 [details]
Numbers Chart Styles Background Border general
Comment 11 Alex Thurgood 2015-09-18 15:16:26 UTC
Created attachment 118830 [details]
Numbers Chart Styles Background Border detail
Comment 12 Alex Thurgood 2015-09-18 15:17:06 UTC
Created attachment 118831 [details]
Numbers Chart Styles Shadow
Comment 13 Alex Thurgood 2015-09-18 15:18:05 UTC
Created attachment 118832 [details]
Numbers Chart Styles Graph type
Comment 14 Bastián Díaz 2015-09-18 15:25:41 UTC
(In reply to Yousuf (Jay) Philips from comment #5)
> (In reply to Bastián Díaz from comment #4)
> > Does this only comes to the colors of charts?
> 
> The colors of the chart data series is one of the pieces that is hoped to be
> covered by this bug enhancement, the others being element layout and element
> styles.
> 
> > See: https://bugs.documentfoundation.org/show_bug.cgi?id=93088
> > 
> > Please check, and if necessary, mark as duplicate.
> > So I can create another report, including color palettes like styles.
> 
> I think your bug maybe related to document theming (bug 90497).
> 
> As an update to this bug report, I brought up the topic of chart styles in
> wednesday's design meeting and discussed it with Heiko and Matthias. I've
> asked them to proposed data series color sets and chart element layouts, and
> others are welcome to do the same.
> 
> My current research on this, as well as chart styles from competing office
> suites can be found at the following link.
> 
> https://drive.google.com/
> folderview?id=0B6qJrVIa0SAlfmZTWFI4MWpCLUh0OXlnYVV5bmtoMXNVU25kRzlHNDZZQ3FDdV
> FvcHU1emc&usp=sharing

I understand. I will change the title of my report to distinguish the concept of "themes". Actually I propose an easy way to attach a color palette to a document (a form could be styles).
Comment 15 Gerry 2015-09-18 20:37:48 UTC
Created attachment 118837 [details]
Stata: Screenshot of UI to apply the different chart styles in Stata

Attached screenshot of Stata UI for chart styles. 

Chart styles in Stata are indeed very simple to use. It is a predefined set of 12 style sets. There are many additional style sets available which can be defined in a kind of programming language (see the Chart Styles wiki page).

These style sets can be applied in the creation of new charts, but also to change charts which do already exist.

The chart styles change a number of features of the charts:
* Chart colours
* Background colour
* Font, Font colour and size
* Frames around the charts
* Size and place of legend

In another screenshot, I will attach a selection of chart styles (applied to the same chart) in Stata.
Comment 16 Gerry 2015-09-18 20:38:37 UTC
Created attachment 118838 [details]
Stata: Selection of five different chart styles applied to the same chart
Comment 17 Gerry 2015-09-18 20:54:45 UTC
> The chart styles would have to be implemented in the chart edit mode, so it
> wouldnt be possible to integrate it into the current styling system found in
> LO. It will likely be implemented in a dialog, where a user could select
> from a collection of various styling options to be applied to their chart,
> and also hopefully implement in the chart sidebar.

Hi Jay, 

the styles system in LibreOffice is really powerful (and outstanding compared to MS Office), but has not really been improved in recent years (it lacks picture styles, document styles, colour sets, table styles and chart styles). 

With regard to chart styles, there are existing synergies with character, paragraph and frame styles, e.g. for chart headings, sub-headings, axis descriptions, legend, legend frames, chart frames, etc. It would be a pity if that is being duplicated.

Also, a predefined set of colours is something which has synergies beyond charts, because it should be also possible to have the same default colours sets for drawings as for charts (when color sets will exist). 

I understand that the chart edit mode might make it difficult (impossible?) to implement it with the existing styles system. But it would be also a pity, if LibreOffice makes with table styles, color sets and chart styles the same mistake like with "auto-formats" for Writer tables. This system was 100% not integrated in the styles system. Not even the logic behind...

Thanks for every progress on chart styles (and others like table styles)!

I think it would be great if the system would allow to "switch" a chart from one chart style with one click to another chart style. Imaging if you have a publication with dozens of charts for an online publication in color and then for the print publication in greyscale. At the moment, this takes ages to reformat those charts in LO.
Comment 18 Yousuf Philips (jay) (retired) 2015-09-19 09:45:54 UTC
(In reply to Gerry from comment #17)
> Hi Jay, 

Hi Gerry,

> the styles system in LibreOffice is really powerful (and outstanding
> compared to MS Office), but has not really been improved in recent years (it
> lacks picture styles, document styles, colour sets, table styles and chart
> styles).

Yes LO's styling system isnt optimal at the moment, but progress is being made with document styles (bug 90497) and i'm hopeful that table styles will soon come after that. Not sure what picture styles are, so you'll have to enlighten me on that.

> With regard to chart styles, there are existing synergies with character,
> paragraph and frame styles, e.g. for chart headings, sub-headings, axis
> descriptions, legend, legend frames, chart frames, etc. It would be a pity
> if that is being duplicated.

Presently LO's chart system is a completely independent module and doesnt support character, paragraph, or cell styles, only direct formatting.

> Also, a predefined set of colours is something which has synergies beyond
> charts, because it should be also possible to have the same default colours
> sets for drawings as for charts (when color sets will exist). 

Yes this is hoped for with the work going on with document theming (bug 90497).

> I understand that the chart edit mode might make it difficult (impossible?)
> to implement it with the existing styles system. But it would be also a
> pity, if LibreOffice makes with table styles, color sets and chart styles
> the same mistake like with "auto-formats" for Writer tables. This system was
> 100% not integrated in the styles system. Not even the logic behind...

I believe that once document theming is implemented, that there would likely be a means of giving the chart edit mode access to the document theming in the file that the chart is placed in. Yes its unfortunate that LO hasnt implemented table styles and more worrying that it doesnt support importing ODF table styles (bug 94076). Looking at Writer's Autoformats dialog, it seems to be copied from WordPerfect. You can read details i've been collecting about table styles here.

https://docs.google.com/document/d/1zOsEe_cj-VnFyuPZcld4-WPjwmdsfsaHuOO8e2dfhU0/edit?usp=sharing

> Thanks for every progress on chart styles (and others like table styles)!

Glad i could move the needle forward.

> I think it would be great if the system would allow to "switch" a chart from
> one chart style with one click to another chart style. Imaging if you have a
> publication with dozens of charts for an online publication in color and
> then for the print publication in greyscale. At the moment, this takes ages
> to reformat those charts in LO.

Yes i'm hopeful that it can be achieved in the future, though presently there isnt any developer who has committed to do it, but atleast we can get things as ready as possible so that it can be implemented or possibly be a GSoC project. Please do give my chart styles document a read when you get a chance, as i have just completed it, with samples.

https://docs.google.com/document/d/1QZ2JchTHZ0_o4CZwMNB-xVqIKJVomrnSw8LetfX-uZ8/edit?usp=sharing
Comment 19 Gerry 2015-09-19 10:02:39 UTC
Thanks a lot Jay.

picture styles: bug 59906. IMHO they should be low priority, but were implemented in MS Office 2007.


Reading your chart styles document, I have more the feeling that LibreOffice should not copy what MS Office did with regard to chart styles. I think the solutions of statistical software are much more powerful (and leave out unuseful chart style options). Also, the idea that it is generally possible to script new chart styles and provide them to other users is great. For example, Stata provides a style made for the "Economist" journal.
Comment 20 Yousuf Philips (jay) (retired) 2015-09-19 11:06:05 UTC
(In reply to Gerry from comment #19)
> picture styles: bug 59906. IMHO they should be low priority, but were
> implemented in MS Office 2007.

Thanks for the link. Yep i had seen them before but totally forgot about it. :D I doubt that would ever get implemented.

> Reading your chart styles document, I have more the feeling that LibreOffice
> should not copy what MS Office did with regard to chart styles.

I'm hoping big but its possible that all of the chart styles might not be implementable, so by having the various pieces that make up the style, it gives us flexibility for implementation, and gives users more customizable options.

> I think the
> solutions of statistical software are much more powerful (and leave out
> unuseful chart style options). Also, the idea that it is generally possible
> to script new chart styles and provide them to other users is great. For
> example, Stata provides a style made for the "Economist" journal.

Havent used stats software, so i'll have to take your word for it, but if users are to create their own custom chart style, there isnt any options that should be lost because it was deemed unuseful.
Comment 21 Yousuf Philips (jay) (retired) 2015-09-20 15:19:50 UTC
Created attachment 118876 [details]
Chart Styles for LibreOffice

Have attached the document i've been working on in Google Docs.
Comment 22 raal 2015-12-16 16:07:36 UTC
*** Bug 96542 has been marked as a duplicate of this bug. ***